SoLineHighlightRenderAction(3)

NAME
SoLineHighlightRenderAction - The SoLineHighlightRenderAction class renders selections with line highlighting.

SYNOPSIS

#include <Inventor/actions/SoLineHighlightRenderAction.h>

Inherits SoGLRenderAction.

  Public Member Functions
virtual SoType getTypeId (void) const
SoLineHighlightRenderAction (void)
SoLineHighlightRenderAction (const SbViewportRegion &viewportregion)
virtual ~SoLineHighlightRenderAction (void)
virtual void apply (SoNode *node)
virtual void apply (SoPath *path)
virtual void apply (const SoPathList &pathlist, SbBool obeysrules=FALSE)
void setVisible (const SbBool visible)
SbBool isVisible (void) const
void setColor (const SbColor &color)
const SbColor & getColor (void)
void setLinePattern (uint16_t pattern)
uint16_t getLinePattern (void) const
void setLineWidth (const float width)
float getLineWidth (void) const

  Static Public Member Functions
static SoType getClassTypeId (void)
static void addMethod (const SoType type, SoActionMethod method)
static void enableElement (const SoType type, const int stackindex)
static void initClass (void)

  Protected Member Functions
virtual const SoEnabledElementsList & getEnabledElements (void) const

  Static Protected Member Functions
static SoEnabledElementsList * getClassEnabledElements (void)
static SoActionMethodList * getClassActionMethods (void)

  Protected Attributes
SbBool hlVisible

  Additional Inherited Members

Detailed Description

The SoLineHighlightRenderAction class renders selections with line highlighting. See the documentation of SoBoxHighlightRenderAction.

The only difference between SoBoxHighlightRenderAction and this action is that this action renders highlights by superposing a wireframe image onto each shape instead of the bounding box when drawing the highlight.

Note: an important limitation for this rendering action is that the superimposition of a wireframe is only guaranteed to work correctly for filled shapes, due to a limitation in OpenGL's glPolygonOffset() functionality. For more information, see the class documentation of the SoPolygonOffset node.

See also
    SoBoxHighlightRenderAction, SoSelection

Constructor & Destructor Documentation

  SoLineHighlightRenderAction::SoLineHighlightRenderAction (void)
Default constructor. Note: passes a default SbViewportRegion to the parent constructor.

  SoLineHighlightRenderAction::SoLineHighlightRenderAction (const SbViewportRegion & viewportregion)
Constructor, taking an explicit viewportregion to render.

  SoLineHighlightRenderAction::~SoLineHighlightRenderAction (void) [virtual]
The destructor.

Member Function Documentation

  SoType SoLineHighlightRenderAction::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoAction. This is used for runtime type checking and 'downward' casting.

Reimplemented from SoGLRenderAction.

  SoType SoLineHighlightRenderAction::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  void SoLineHighlightRenderAction::addMethod (const SoType type, SoActionMethod method) [static]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

  void SoLineHighlightRenderAction::enableElement (const SoType type, const int stackindex) [static]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

  const SoEnabledElementsList & SoLineHighlightRenderAction::getEnabledElements (void) const [protected], [virtual]
Returns list of enabled elements.

Reimplemented from SoGLRenderAction.

  SoEnabledElementsList * SoLineHighlightRenderAction::getClassEnabledElements (void) [static], [protected]
Returns list of enabled elements for this class. The enabledElements and methods variables are protected in the original OIV API. This is not such a good idea, since exposed static class member variables is a major grievance with regard to Win32 DLLs. This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

  SoActionMethodList * SoLineHighlightRenderAction::getClassActionMethods (void) [static], [protected]
Returns list of action methods for this class. The enabledElements and methods variables are protected in the original OIV API. This is not such a good idea, since exposed static class member variables is a major grievance with regard to Win32 DLLs. This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

  void SoLineHighlightRenderAction::initClass (void) [static]
Initializes the runtime type system for this class, and sets up the enabled elements and action method list.

  void SoLineHighlightRenderAction::apply (SoNode * root) [virtual]
Applies the action to the scene graph rooted at root.

Note that you should not apply an action to a node with a zero reference count. The behavior in that case is undefined.

Reimplemented from SoAction.

  void SoLineHighlightRenderAction::apply (SoPath * path) [virtual]
Applies the action to the parts of the graph defined by path.

Note that an SoPath will also contain all nodes that may influence e.g. geometry nodes in the path. So for instance applying an SoGLRenderAction on an SoPath will render that path as expected in the view, where geometry will get its materials, textures, and other appearance settings correctly.

If the path ends in an SoGroup node, the action will also traverse the tail node's children.

Reimplemented from SoAction.

  void SoLineHighlightRenderAction::apply (const SoPathList & pathlist, SbBool obeysrules = FALSE) [virtual]
Applies action to the graphs defined by pathlist. If obeysrules is set to TRUE, pathlist must obey the following four conditions (which is the case for path lists returned from search actions for non-group nodes and path lists returned from picking actions):

All paths must start at the same head node. All paths must be sorted in traversal order. The paths must be unique. No path can continue through the end point of another path.

See also
    SoAction::apply(SoPath * path)

Reimplemented from SoAction.

  void SoLineHighlightRenderAction::setVisible (const SbBool visible)
Sets if highlight wireframes should be visible when rendering. Defaults to TRUE.

  SbBool SoLineHighlightRenderAction::isVisible (void) const
Return if selection wireframes should be visible.

  void SoLineHighlightRenderAction::setColor (const SbColor & color)
Sets the color of the wireframes. Defaults to red.

  const SbColor & SoLineHighlightRenderAction::getColor (void)
Returns color of selection wireframes.

  void SoLineHighlightRenderAction::setLinePattern (uint16_t pattern)
Sets the line pattern used when drawing wireframes. Defaults to 0xffff (i.e. full, unstippled lines).

  uint16_t SoLineHighlightRenderAction::getLinePattern (void) const
Returns line pattern used when drawing wireframe.

  void SoLineHighlightRenderAction::setLineWidth (const float width)
Sets the line width used when drawing wireframe. Defaults to 3 (measured in screen pixels).

  float SoLineHighlightRenderAction::getLineWidth (void) const
Returns the line width used when drawing wireframe.

Member Data Documentation

  SoLineHighlightRenderAction::hlVisible [protected]
Boolean which decides whether or not the highlights for selected nodes should be visible.

Author

Generated automatically by Doxygen for Coin from the source code.